package com.fp.persistence.parmas.param;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import javax.persistence.Version;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMTIPOTRAMITE*/
@Entity(name="TarmTipoTramite")
@Table(name="TARMTIPOTRAMITE")
public class TarmTipoTramite extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmTipoTramite
*/
@Id
@Column(name="CTIPOTRAMITE" ,nullable=false, updatable=false)
private String pk;
@Column(name="NOMBRE", nullable=false)

/**
* Descripcion del tipo de tramite
*/
private String nombre;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Manejo de optimistic locking del registro
*/
private Integer recordversion;

/**Contructor por defecto*/
public TarmTipoTramite(){
}
/**Contructor de TarmTipoTramite
@param pPk Clave Primaria del entity
@param pNombre Descripcion del tipo de tramite
*/
public TarmTipoTramite(String pPk,String pNombre){
 this();
 pk=pPk;
 nombre=pNombre;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmTipoTramite
*/
public static TarmTipoTramite find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmTipoTramite obj = pEntityManager.find(TarmTipoTramite.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmTipoTramite
@return El objeto que referencia a la Clave primaria de TarmTipoTramite
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmTipoTramite
@param pPk El objeto que referencia a la nueva Clave primaria de TarmTipoTramite
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de nombre
@return valor de nombre*/
public String getNombre(){
  return nombre;
}
/**Fija el valor de nombre
@param pNombre nuevo Valor de nombre*/
public void setNombre(String pNombre){
  nombre=pNombre;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmTipoTramite))return false;
    TarmTipoTramite that = (TarmTipoTramite) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmTipoTramite
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmTipoTramite
*/
public Object createInstance(){
 TarmTipoTramite instance=new TarmTipoTramite();	
 return instance;
}
/**Clona la entidad TarmTipoTramite
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmTipoTramite p=(TarmTipoTramite)this.clone();
  return p;
}
}
